"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const Annotation_1 = require("../annotation/Annotation");
const BeanFactory_1 = require("../BeanFactory");
const MethodRequestFactory_1 = require("../engine/MethodRequestFactory");
/**
 * 顶层baseController
 * T 表单类型
 * S 筛选类型
 * R 列表返回类型
 * ID 主键
 */
class BaseController extends MethodRequestFactory_1.MethodRequestFactory {
    /**
     * 新增
     * @returns {AxiosPromise}
     */
    insert(data) {
        return this.getService().insert(this.request(data));
    }
    /**
     * 删除
     * @returns {AxiosPromise}
     */
    deletes(ids) {
        return this.getService().deletes(this.request(ids));
    }
    /**
     * 单条删除<根据主键删除>
     * @param id
     */
    delete(id) {
        return this.getService().delete(this.request({ id: id }));
    }
    /**
     * 根据ID查询单调信息
     * @param id 查询详情的ID
     */
    findById(id) {
        return this.getService().findById(this.request({ id: id }));
    }
    /**
     * 修改
     * @param data 修改的数据
     */
    update(data) {
        return this.getService().update(this.request(data));
    }
    /**
     *  分页查询
     * @param data 查询的筛选的数据
     */
    queryManagerListPage(data) {
        return this.getService().queryManagerListPage(this.request(data));
    }
    /**
     *  分页查询
     * @param data 筛选数据
     * @returns {*|AxiosPromise}
     */
    queryListPage(data) {
        return this.getService().queryListPage(this.request(data));
    }
    /**
     * 不分页查询
     * @param data
     * @returns {*}
     */
    query(data) {
        return this.getService().query(this.request(data));
    }
}
__decorate([
    (0, Annotation_1.PostMapping)("insert"),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Object)
], BaseController.prototype, "insert", null);
__decorate([
    (0, Annotation_1.DeleteMapping)("deletes"),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Array]),
    __metadata("design:returntype", Object)
], BaseController.prototype, "deletes", null);
__decorate([
    (0, Annotation_1.DeleteMapping)("delete", { dataType: BeanFactory_1.DataType.PARAMS }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Object)
], BaseController.prototype, "delete", null);
__decorate([
    (0, Annotation_1.GetMapping)("findById"),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Object)
], BaseController.prototype, "findById", null);
__decorate([
    (0, Annotation_1.PutMapping)("update"),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Object)
], BaseController.prototype, "update", null);
__decorate([
    (0, Annotation_1.GetMapping)("queryManagerListPage"),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Object)
], BaseController.prototype, "queryManagerListPage", null);
__decorate([
    (0, Annotation_1.GetMapping)("queryListPage"),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Object)
], BaseController.prototype, "queryListPage", null);
__decorate([
    (0, Annotation_1.GetMapping)("query"),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Object)
], BaseController.prototype, "query", null);
exports.default = BaseController;
