"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BeanFactoryQueue = void 0;
const BeanFactory_1 = require("../BeanFactory");
/**
 * bean相关存储
 */
const beanQueue = new Array();
/**
 * bean工厂队列
 */
class BeanFactoryQueue {
    /**
     * 添加可执行的队列
     * @param queueData 队列相关数据
     */
    static addQueue(queueData) {
        let l = BeanFactory_1.BeanFactory.getBean(queueData.type);
        if (l != null) {
            queueData.target[queueData.propertyKey] = l;
        }
        else {
            beanQueue.push(queueData);
        }
    }
    /**
     * 消费队列信息
     * @param target
     * @param clObj
     */
    static consumeQueue(target, clObj) {
        let arr = beanQueue.filter((v, index, arr) => {
            return clObj instanceof v.type;
        });
        arr.forEach((v) => {
            v.target[v.propertyKey] = clObj;
        });
    }
}
exports.BeanFactoryQueue = BeanFactoryQueue;
